# coding: utf-8

# flake8: noqa

"""
    Cythereal Dashboard API

     The API used exclusively by the MAGIC Dashboard for populating charts, graphs, tables, etc... on the dashboard.  # API Conventions  **All responses** MUST be of type `APIResponse` and contain the following fields:  * `api_version` |  The current api version * `success` | Boolean value indicating if the operation succeeded. * `code` | Status code. Typically corresponds to the HTTP status code.  * `message` | A human readable message providing more details about the operation. Can be null or empty.  **Successful operations** MUST return a `SuccessResponse`, which extends `APIResponse` by adding:  * `data` | Properties containing the response object. * `success` | MUST equal True  When returning objects from a successful response, the `data` object SHOULD contain a property named after the requested object type. For example, the `/alerts` endpoint should return a response object with `data.alerts`. This property SHOULD  contain a list of the returned objects. For the `/alerts` endpoint, the `data.alerts` property contains a list of MagicAlerts objects. See the `/alerts` endpoint documentation for an example.  **Failed Operations** MUST return an `ErrorResponse`, which extends `APIResponse` by adding:  * `success` | MUST equal False.   # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@cythereal.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

# import apis into sdk package
from cythereal_dashboard.api.alerts_api import AlertsApi
from cythereal_dashboard.api.binaries_api import BinariesApi
from cythereal_dashboard.api.campaigns_api import CampaignsApi
from cythereal_dashboard.api.charts_api import ChartsApi
from cythereal_dashboard.api.investigations_api import InvestigationsApi
from cythereal_dashboard.api.tables_api import TablesApi
from cythereal_dashboard.api.update_api import UpdateApi

# import ApiClient
from cythereal_dashboard.api_client import ApiClient
from cythereal_dashboard.configuration import Configuration
# import models into sdk package
from cythereal_dashboard.models.add_to_investigation import AddToInvestigation
from cythereal_dashboard.models.alert_list import AlertList
from cythereal_dashboard.models.alert_model import AlertModel
from cythereal_dashboard.models.api_response import ApiResponse
from cythereal_dashboard.models.binary_graph_list import BinaryGraphList
from cythereal_dashboard.models.binary_graph_model import BinaryGraphModel
from cythereal_dashboard.models.binary_list import BinaryList
from cythereal_dashboard.models.binary_model import BinaryModel
from cythereal_dashboard.models.binary_table_list import BinaryTableList
from cythereal_dashboard.models.binary_table_model import BinaryTableModel
from cythereal_dashboard.models.campaign_graph_list import CampaignGraphList
from cythereal_dashboard.models.campaign_graph_model import CampaignGraphModel
from cythereal_dashboard.models.campaign_list import CampaignList
from cythereal_dashboard.models.campaign_map_list import CampaignMapList
from cythereal_dashboard.models.campaign_map_model import CampaignMapModel
from cythereal_dashboard.models.campaign_map_model_children import CampaignMapModelChildren
from cythereal_dashboard.models.campaign_model import CampaignModel
from cythereal_dashboard.models.categories import Categories
from cythereal_dashboard.models.category import Category
from cythereal_dashboard.models.color import Color
from cythereal_dashboard.models.evasiveness import Evasiveness
from cythereal_dashboard.models.inline_response200 import InlineResponse200
from cythereal_dashboard.models.inline_response409 import InlineResponse409
from cythereal_dashboard.models.investigation_list import InvestigationList
from cythereal_dashboard.models.investigation_model import InvestigationModel
from cythereal_dashboard.models.investigation_name import InvestigationName
from cythereal_dashboard.models.remove_from_investigation import RemoveFromInvestigation
from cythereal_dashboard.models.sha1 import Sha1
from cythereal_dashboard.models.size import Size
from cythereal_dashboard.models.timestamp import Timestamp
from cythereal_dashboard.models.yara_id import YaraId
from cythereal_dashboard.models.yara_rule import YaraRule
from cythereal_dashboard.models.error_response import ErrorResponse
from cythereal_dashboard.models.success_response import SuccessResponse
from cythereal_dashboard.models.add_to_investigation_response import AddToInvestigationResponse
from cythereal_dashboard.models.alert import Alert
from cythereal_dashboard.models.alert_created import AlertCreated
from cythereal_dashboard.models.alert_email_sent import AlertEmailSent
from cythereal_dashboard.models.alert_exists import AlertExists
from cythereal_dashboard.models.alert_list_response import AlertListResponse
from cythereal_dashboard.models.binary import Binary
from cythereal_dashboard.models.binary_graph_list_response import BinaryGraphListResponse
from cythereal_dashboard.models.binary_list_response import BinaryListResponse
from cythereal_dashboard.models.binary_table_list_response import BinaryTableListResponse
from cythereal_dashboard.models.campaign import Campaign
from cythereal_dashboard.models.campaign_graph_list_response import CampaignGraphListResponse
from cythereal_dashboard.models.campaign_list_response import CampaignListResponse
from cythereal_dashboard.models.campaign_map_list_response import CampaignMapListResponse
from cythereal_dashboard.models.invalid_api_key import InvalidApiKey
from cythereal_dashboard.models.investigation import Investigation
from cythereal_dashboard.models.investigation_exists import InvestigationExists
from cythereal_dashboard.models.investigation_list_response import InvestigationListResponse
from cythereal_dashboard.models.missing_parameter import MissingParameter
from cythereal_dashboard.models.new_investigation import NewInvestigation
from cythereal_dashboard.models.remove_from_investigation_response import RemoveFromInvestigationResponse
from cythereal_dashboard.models.unauthorized_api_key import UnauthorizedApiKey
