# coding: utf-8

"""
    Cythereal Dashboard API

     The API used exclusively by the MAGIC Dashboard for populating charts, graphs, tables, etc... on the dashboard.  # API Conventions  **All responses** MUST be of type `APIResponse` and contain the following fields:  * `api_version` |  The current api version * `success` | Boolean value indicating if the operation succeeded. * `code` | Status code. Typically corresponds to the HTTP status code.  * `message` | A human readable message providing more details about the operation. Can be null or empty.  **Successful operations** MUST return a `SuccessResponse`, which extends `APIResponse` by adding:  * `data` | Properties containing the response object. * `success` | MUST equal True  When returning objects from a successful response, the `data` object SHOULD contain a property named after the requested object type. For example, the `/alerts` endpoint should return a response object with `data.alerts`. This property SHOULD  contain a list of the returned objects. For the `/alerts` endpoint, the `data.alerts` property contains a list of MagicAlerts objects. See the `/alerts` endpoint documentation for an example.  **Failed Operations** MUST return an `ErrorResponse`, which extends `APIResponse` by adding:  * `success` | MUST equal False.   # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@cythereal.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class InvestigationModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'InvestigationName',
        'name': 'InvestigationName',
        'size': 'Size',
        'category': 'Category',
        'color': 'Color',
        'yara_id': 'YaraId',
        'yara_rule': 'YaraRule',
        'yara_id_unpacked': 'YaraId',
        'yara_rule_unpacked': 'YaraRule',
        'evasiveness': 'Evasiveness',
        'stddev_evasiveness': 'Evasiveness',
        'value': 'float'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'size': 'size',
        'category': 'category',
        'color': 'color',
        'yara_id': 'yara_id',
        'yara_rule': 'yara_rule',
        'yara_id_unpacked': 'yara_id_unpacked',
        'yara_rule_unpacked': 'yara_rule_unpacked',
        'evasiveness': 'evasiveness',
        'stddev_evasiveness': 'stddev_evasiveness',
        'value': 'value'
    }

    def __init__(self, id=None, name=None, size=None, category=None, color=None, yara_id=None, yara_rule=None, yara_id_unpacked=None, yara_rule_unpacked=None, evasiveness=None, stddev_evasiveness=None, value=None):  # noqa: E501
        """InvestigationModel - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._name = None
        self._size = None
        self._category = None
        self._color = None
        self._yara_id = None
        self._yara_rule = None
        self._yara_id_unpacked = None
        self._yara_rule_unpacked = None
        self._evasiveness = None
        self._stddev_evasiveness = None
        self._value = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if size is not None:
            self.size = size
        if category is not None:
            self.category = category
        if color is not None:
            self.color = color
        if yara_id is not None:
            self.yara_id = yara_id
        if yara_rule is not None:
            self.yara_rule = yara_rule
        if yara_id_unpacked is not None:
            self.yara_id_unpacked = yara_id_unpacked
        if yara_rule_unpacked is not None:
            self.yara_rule_unpacked = yara_rule_unpacked
        if evasiveness is not None:
            self.evasiveness = evasiveness
        if stddev_evasiveness is not None:
            self.stddev_evasiveness = stddev_evasiveness
        if value is not None:
            self.value = value

    @property
    def id(self):
        """Gets the id of this InvestigationModel.  # noqa: E501


        :return: The id of this InvestigationModel.  # noqa: E501
        :rtype: InvestigationName
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InvestigationModel.


        :param id: The id of this InvestigationModel.  # noqa: E501
        :type: InvestigationName
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this InvestigationModel.  # noqa: E501


        :return: The name of this InvestigationModel.  # noqa: E501
        :rtype: InvestigationName
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InvestigationModel.


        :param name: The name of this InvestigationModel.  # noqa: E501
        :type: InvestigationName
        """

        self._name = name

    @property
    def size(self):
        """Gets the size of this InvestigationModel.  # noqa: E501


        :return: The size of this InvestigationModel.  # noqa: E501
        :rtype: Size
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this InvestigationModel.


        :param size: The size of this InvestigationModel.  # noqa: E501
        :type: Size
        """

        self._size = size

    @property
    def category(self):
        """Gets the category of this InvestigationModel.  # noqa: E501


        :return: The category of this InvestigationModel.  # noqa: E501
        :rtype: Category
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this InvestigationModel.


        :param category: The category of this InvestigationModel.  # noqa: E501
        :type: Category
        """

        self._category = category

    @property
    def color(self):
        """Gets the color of this InvestigationModel.  # noqa: E501


        :return: The color of this InvestigationModel.  # noqa: E501
        :rtype: Color
        """
        return self._color

    @color.setter
    def color(self, color):
        """Sets the color of this InvestigationModel.


        :param color: The color of this InvestigationModel.  # noqa: E501
        :type: Color
        """

        self._color = color

    @property
    def yara_id(self):
        """Gets the yara_id of this InvestigationModel.  # noqa: E501


        :return: The yara_id of this InvestigationModel.  # noqa: E501
        :rtype: YaraId
        """
        return self._yara_id

    @yara_id.setter
    def yara_id(self, yara_id):
        """Sets the yara_id of this InvestigationModel.


        :param yara_id: The yara_id of this InvestigationModel.  # noqa: E501
        :type: YaraId
        """

        self._yara_id = yara_id

    @property
    def yara_rule(self):
        """Gets the yara_rule of this InvestigationModel.  # noqa: E501


        :return: The yara_rule of this InvestigationModel.  # noqa: E501
        :rtype: YaraRule
        """
        return self._yara_rule

    @yara_rule.setter
    def yara_rule(self, yara_rule):
        """Sets the yara_rule of this InvestigationModel.


        :param yara_rule: The yara_rule of this InvestigationModel.  # noqa: E501
        :type: YaraRule
        """

        self._yara_rule = yara_rule

    @property
    def yara_id_unpacked(self):
        """Gets the yara_id_unpacked of this InvestigationModel.  # noqa: E501


        :return: The yara_id_unpacked of this InvestigationModel.  # noqa: E501
        :rtype: YaraId
        """
        return self._yara_id_unpacked

    @yara_id_unpacked.setter
    def yara_id_unpacked(self, yara_id_unpacked):
        """Sets the yara_id_unpacked of this InvestigationModel.


        :param yara_id_unpacked: The yara_id_unpacked of this InvestigationModel.  # noqa: E501
        :type: YaraId
        """

        self._yara_id_unpacked = yara_id_unpacked

    @property
    def yara_rule_unpacked(self):
        """Gets the yara_rule_unpacked of this InvestigationModel.  # noqa: E501


        :return: The yara_rule_unpacked of this InvestigationModel.  # noqa: E501
        :rtype: YaraRule
        """
        return self._yara_rule_unpacked

    @yara_rule_unpacked.setter
    def yara_rule_unpacked(self, yara_rule_unpacked):
        """Sets the yara_rule_unpacked of this InvestigationModel.


        :param yara_rule_unpacked: The yara_rule_unpacked of this InvestigationModel.  # noqa: E501
        :type: YaraRule
        """

        self._yara_rule_unpacked = yara_rule_unpacked

    @property
    def evasiveness(self):
        """Gets the evasiveness of this InvestigationModel.  # noqa: E501


        :return: The evasiveness of this InvestigationModel.  # noqa: E501
        :rtype: Evasiveness
        """
        return self._evasiveness

    @evasiveness.setter
    def evasiveness(self, evasiveness):
        """Sets the evasiveness of this InvestigationModel.


        :param evasiveness: The evasiveness of this InvestigationModel.  # noqa: E501
        :type: Evasiveness
        """

        self._evasiveness = evasiveness

    @property
    def stddev_evasiveness(self):
        """Gets the stddev_evasiveness of this InvestigationModel.  # noqa: E501


        :return: The stddev_evasiveness of this InvestigationModel.  # noqa: E501
        :rtype: Evasiveness
        """
        return self._stddev_evasiveness

    @stddev_evasiveness.setter
    def stddev_evasiveness(self, stddev_evasiveness):
        """Sets the stddev_evasiveness of this InvestigationModel.


        :param stddev_evasiveness: The stddev_evasiveness of this InvestigationModel.  # noqa: E501
        :type: Evasiveness
        """

        self._stddev_evasiveness = stddev_evasiveness

    @property
    def value(self):
        """Gets the value of this InvestigationModel.  # noqa: E501


        :return: The value of this InvestigationModel.  # noqa: E501
        :rtype: float
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this InvestigationModel.


        :param value: The value of this InvestigationModel.  # noqa: E501
        :type: float
        """
        if value is not None and value > 1.0:  # noqa: E501
            raise ValueError("Invalid value for `value`, must be a value less than or equal to `1.0`")  # noqa: E501
        if value is not None and value < 0.1:  # noqa: E501
            raise ValueError("Invalid value for `value`, must be a value greater than or equal to `0.1`")  # noqa: E501

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InvestigationModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InvestigationModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
